<?php
/*
 #########################################################################
 #                       xt:Commerce  4.1 Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2014 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce  4.1 Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id$
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

if (!class_exists('csv_pro_api', true))
	include_once _SRV_WEBROOT.'plugins/xt_pro_import/classes/class.csv_pro_api.php';

if ($request['get']=='pro_export_types') {
	if(!isset($result)) $result = array();
	$result[] =  array('id' => 'export',
			'name' => 'Export',
			'desc' => '');
	$result[] =  array('id' => 'import',
			'name' => 'Import',
			'desc' => '');
	$result[] = array(
		'id' => 'update',
		'name' => 'Update',
		'desc' => '',
	);
}
if ($request['get']=='pro_export_typesspec') {
	if(!isset($result)) $result = array();
	$result[] =  array('id' => 'products',
			'name' => 'Products',
			'desc' => '');
	$result[] =  array('id' => 'price_groups',
			'name' => 'Price groups',
			'desc' => '');
}
if ($request['get']=='pro_export_matching') {
	if(!isset($result)) $result = array();


	$result[] =  array('id' => 'products_id',
			'name' => 'Products - ID',
			'desc' => '');
	$result[] =  array('id' => 'products_model',
			'name' => 'Products - Model',
			'desc' => '');
	$result[] =  array('id' => 'products_ean',
			'name' => 'Products - EAN',
			'desc' => '');
	$result[] =  array('id' => 'external_id',
			'name' => 'Products - External ID',
			'desc' => '');
	$result[] =  array('id' => 'id',
			'name' => 'ID',
			'desc' => '');
}
if ($request['get']=='pro_export_matching_2') {
	if(!isset($result)) $result = array();

	$result[] =  array('id' => '',
			'name' => 'None',
			'desc' => '');
	$result[] =  array('id' => 'manufacturers_id',
			'name' => 'Manufacturers - ID',
			'desc' => '');
}
if ($request['get']=='pro_export_delimiter') {
	if(!isset($result)) $result = array();
	$result[] = array ('id' => ';', 'name' => ';', 'desc' => ';');
	$result[] = array ('id' => ',', 'name' => ',', 'desc' => ',');
}
if ($request['get']=='pro_export_enclosure') {
	if(!isset($result)) $result = array();
	$result[] = array ('id' => '"', 'name' => '"', 'desc' => '"');
	$result[] = array ('id' => "'", 'name' => "'", 'desc' => "'");
}

// Get supported fields for given type for action insert/update
if ($request['get'] == 'get_supported_fields_for_type') {
	if (!isset($request['ei_type_spec'])) {
		$type = 'products';
	} 
	else {
		$type = $request['ei_type_spec'];
	}
	
	switch ($type) {
		case 'products':
			
			$supportedFields = csv_pro_api::getSupporttedFieldsForType($type);
			$supportedFields = array_map('getDisplayName', $supportedFields);
			asort($supportedFields);
			
			$supportedFields = array('No selection' => 'No selection') + $supportedFields;
			// Prepare dropdown data
			foreach ($supportedFields as $field => $displayName) {
				$result[] = array (
						'id' => $field,
						'name' => $displayName,
						'desc' => $displayName,
				);
			}
			
			break;
		case 'price_groups':
			$supportedFields = csv_pro_api::getSupporttedFieldsForType($type);
			
			foreach ($supportedFields as $id => $name) {
				$supportedFields[$id] = getDisplayName($name, "group prices");
			}
			//$supportedFields = array_map('getDisplayName', $supportedFields);
			asort($supportedFields);
				
			$supportedFields = array('No selection' => 'No selection') + $supportedFields;
			// Prepare dropdown data
			foreach ($supportedFields as $field => $displayName) {
				$result[] = array (
						'id' => $field,
						'name' => $displayName,
						'desc' => $displayName,
				);
			}
			break;
		default:
			// Not implemented yet
			break;
	}
}

// Get CSV header values as dropdown values
if ($request['get'] == 'csv_columns' && isset($request['id'])) {
	// Get current exported record to determine filename we should get columns from
	$sql = "SELECT * FROM ".TABLE_PROIMPORTPLUGIN." WHERE id = '".$filter->_charNum($request['id'])."'";
	$rs = $db->Execute($sql);
	if ($rs->RecordCount()==1) {
		$recordData = $rs->fields;
		
		$file = _SRV_WEBROOT.'export/'.$recordData['ei_filename'];
		
		if (file_exists($file)) {
			$groupedColumns = csv_pro_api::getCsvColumns($file, $recordData['ei_delimiter'], $recordData['ei_enclosure']);
			$groupedColumns = array('No selection' => 'No selection') + $groupedColumns;
			// Finally prepare dropdown data
			foreach ($groupedColumns as $field) {
				$result[] = array (
						'id' => $field,
						'name' => $field,
						'desc' => $field,
				);
			}
		}
	}
}

if ($request['get'] == 'get_export_files') {
	$files = glob(_SRV_WEBROOT.'export/*');
	$files = array_diff($files, array('.', '..', '.htaccess', 'htpasswd'));
	
	foreach ($files as $file) {
		$result[] = array (
				'id' => basename($file),
				'name' => basename($file),
				'desc' => basename($file),
		);
	}
}

function getDisplayName($dbFieldName, $table_name = 'products') {
	$parts = explode('_', $dbFieldName);
	if (!is_array($parts))
		$parts = array($parts);
	
	if ($parts[0] != $table_name) {
		$parts = array_merge(array($table_name), $parts);
	}
	foreach ($parts as &$part) {
		$part = ucfirst($part);
	}
	
	$firstElement = array_shift($parts);
	if (!is_array($parts)) $parts = array();
	
	$separator = (empty($parts) ? '' : ' - ');
	
	return $firstElement . $separator . join(' ', $parts);
}

?>